/* hrr_item_memory_TEST1.pl */


/*
Run these tests by loading autotest and 
then loading this file.
*/


:- module( hrr_item_memory_TEST1, [
                                  ]
         ).


:- use_module( hrr(hrr_vectors) ).
:- use_module( hrr(hrr_item_memory) ).


:- '$test'(( D=10000
           , hrr_item_memory_retractall
           , hrr_item_memory_name( a, D, A )
           , hrr_item_memory_name( b, D, B )
           , hrr_vector_bind( A, B, AB ), hrr_vector_probe( AB, B, A2 )
           , A == A2
           ) :: s
          ).

:- '$test'(( D=10000
           , hrr_item_memory_retractall
           , hrr_item_memory_name( c, D, C1 )
           , hrr_item_memory_name( c, D, C2 )
           , C1 == C2
           ) :: s
          ).
%
% C1 and C2 should refer to the same
% random vector, generated by the first
% call to hrr_item_memory_name.

:- '$test'(( D=10000
           , hrr_item_memory_retractall
           , hrr_item_memory_name( c, D, C1 )
           , hrr_item_memory_retractall
           , hrr_item_memory_name( c, D, C2 )
           , C1 \== C2
           ) :: s
          ).
%
% C1 and C2 are now _different_ random vectors.

:- '$test'(( D=10000
           , hrr_item_memory_retractall
           , hrr_item_memory_name( capital, D, Capital )
           , hrr_item_memory_name( paris, D, Paris )
           , hrr_item_memory_name( location, D, Location )
           , hrr_item_memory_name( we, D, WE )
           , hrr_item_memory_name( money, D, Money )
           , hrr_item_memory_name( euro, D, Euro )
           , hrr_vector_bind( Capital, Paris, CP )
           , hrr_vector_bind( Location, WE, LWE )
           , hrr_vector_bind( Money, Euro, ME )
           , hrr_vector_merge( [CP,LWE,ME], France )
           , hrr_vector_probe( France, Capital, CF )
           , hrr_vector_clean( CF, D, BestMatchAtom, BestMatchVector, _Sim )
           , BestMatchAtom == paris 
           , BestMatchVector == Paris
           ) :: s
          ).

