/* isv_TEST1.pl */


/*
Run these tests by loading autotest and 
then loading this file.
*/


:- module( isv_TEST1, [
                      ]
         ).


:- use_module( hrr(isv) ).
:- use_module( hrr(hrr_item_memory) ).


:- '$test'(( isv_assert_dimension(10000)
           , isv_dimension( D ), D==10000
           ) :: s
          ).

:- '$test'(( isv_assert_dimension(10000)
           , isv_dimension( D ), D==100001
           ) :: f
          ).

:- '$test'(( X isv a
           , hrr_item_memory( a, Vec ), Vec == X
           ) :: s
          ).

:- '$test'(( hrr_item_memory_retractall
           , not( hrr_item_memory(a,_) )
           ) :: s
          ).

:- '$test'(( A1 isv a
           , A2 isv (a bind b) probe b
           , A1 == A2
           ) :: s
          ).

:- '$test'(( A1 isv a
           , A2 isv (b bind a) probe b
           , A1 == A2
           ) :: s
          ).

:- '$test'(( hrr_item_memory_retractall
           , france isv merge(capital bind paris,location bind we,money bind euro)
           ) :: s
          ).

:- '$test'(( (V-_Similarity) isv clean(france probe capital)
           , V == paris
           ) :: s
          ).

:- '$test'(( (V-_Similarity) isv clean(france probe paris)
           , V == capital
           ) :: s
          ).

:- '$test'(( france ?= [capital-P,paris-C,money-E,euro-M,location-WE,we-L]
           , P==paris, C==capital, E==euro, M==money, WE==we, L==location
           ) :: s
          ).

:- '$test'(( sweden isv merge(capital bind stockholm,location bind nwe,money bind krona)
           ) :: s
          ).

:- '$test'(( (V-_Similarity) isv clean(sweden probe capital)
           , V == stockholm
           ) :: s
          ).

:- '$test'(( (V-_Similarity) isv clean(sweden probe stockholm)
           , V == capital
           ) :: s
          ).

:- '$test'(( sweden ?= [capital-S,stockholm-C,money-K,krona-M,location-NWE,nwe-L]
           , S==stockholm, C==capital, K==krona, M==money, NWE==nwe, L==location
           ) :: s
          ).
